"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = exports.generateQueryString = void 0;
const Formatter = __importStar(require("@himenon/openapi-parameter-formatter"));
const http = __importStar(require("./http"));
const generateQueryString = (queryParameters, additionalString) => {
    if (!queryParameters) {
        return undefined;
    }
    const queries = Object.entries(queryParameters).reduce((queryStringList, [key, item]) => {
        if (!item.value) {
            return queryStringList;
        }
        if (!item.style) {
            return queryStringList.concat(`${key}=${item.value}`);
        }
        const result = Formatter.QueryParameter.generate(key, item);
        if (result) {
            return queryStringList.concat(result);
        }
        return queryStringList;
    }, []);
    if (additionalString) {
        return [...queries, additionalString].join("&");
    }
    return queries.join("&");
};
exports.generateQueryString = generateQueryString;
const create = (params) => {
    const { socketPath } = params;
    const apiClientImpl = {
        request: async (httpMethod, url, headers, requestBody, queryParameters, requestOptions) => {
            // Docker's openapi Schema incorrectly uses filters as query parameter
            const { filters, ...omitedQueryParamsteres } = queryParameters || {};
            const query = (0, exports.generateQueryString)(omitedQueryParamsteres, filters === null || filters === void 0 ? void 0 : filters.value);
            const requestUrl = query ? url + "?" + encodeURI(query) : url;
            const requestHeaders = {
                ...headers,
            };
            const response = await http.request({
                socketPath: socketPath,
                method: httpMethod,
                headers: requestHeaders,
                path: requestUrl,
                requestBody: requestBody,
                hijack: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.hijack,
                isStream: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.isStream,
                onHijackRequest: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.onHijackRequest,
                onResponse: requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.onResponse,
            });
            return response;
        },
    };
    return apiClientImpl;
};
exports.create = create;
