//
// Generated by @himenon/openapi-typescript-code-generator v0.16.0
//
// OpenApi : 3.0.0
//
//
export class Client {
    constructor(apiClient, baseUrl) {
        this.apiClient = apiClient;
        this.baseUrl = baseUrl.replace(/\/$/, "");
    }
    /**
     * List containers
     * Returns a list of containers. For details on the format, see [the inspect endpoint](#operation/ContainerInspect).
     *
     * Note that it uses a different, smaller representation of a container than inspecting a single container. For example,
     * the list of linked containers is not propagated .
     *
     * operationId: ContainerList
     * Request URI: /containers/json
     */
    async ContainerList(params, option) {
        const url = this.baseUrl + `/containers/json`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            all: { value: params.parameter.all, explode: false },
            limit: { value: params.parameter.limit, explode: false },
            size: { value: params.parameter.size, explode: false },
            filters: { value: params.parameter.filters, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a container
     * operationId: ContainerCreate
     * Request URI: /containers/create
     */
    async ContainerCreate(params, option) {
        const url = this.baseUrl + `/containers/create`;
        const headers = {
            "Content-Type": params.headers["Content-Type"],
            Accept: "application/json",
        };
        const queryParameters = {
            name: { value: params.parameter.name, explode: false },
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Inspect a container
     * Return low-level information about a container.
     * operationId: ContainerInspect
     * Request URI: /containers/{id}/json
     */
    async ContainerInspect(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/json`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            size: { value: params.parameter.size, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List processes running inside a container
     * On Unix systems, this is done by running the `ps` command. This endpoint is not supported on Windows.
     * operationId: ContainerTop
     * Request URI: /containers/{id}/top
     */
    async ContainerTop(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/top`;
        const headers = {
            Accept: params.headers.Accept,
        };
        const queryParameters = {
            ps_args: { value: params.parameter.ps_args, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get container logs
     * Get `stdout` and `stderr` logs from a container.
     *
     * Note: This endpoint works only for containers with the `json-file` or `journald` logging driver.
     *
     * operationId: ContainerLogs
     * Request URI: /containers/{id}/logs
     */
    async ContainerLogs(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/logs`;
        const headers = {
            Accept: params.headers.Accept,
        };
        const queryParameters = {
            follow: { value: params.parameter.follow, explode: false },
            stdout: { value: params.parameter.stdout, explode: false },
            stderr: { value: params.parameter.stderr, explode: false },
            since: { value: params.parameter.since, explode: false },
            until: { value: params.parameter.until, explode: false },
            timestamps: { value: params.parameter.timestamps, explode: false },
            tail: { value: params.parameter.tail, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get changes on a container’s filesystem
     * Returns which files in a container's filesystem have been added, deleted,
     * or modified. The `Kind` of modification can be one of:
     *
     * - `0`: Modified
     * - `1`: Added
     * - `2`: Deleted
     *
     * operationId: ContainerChanges
     * Request URI: /containers/{id}/changes
     */
    async ContainerChanges(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/changes`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Export a container
     * Export the contents of a container as a tarball.
     * operationId: ContainerExport
     * Request URI: /containers/{id}/export
     */
    async ContainerExport(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/export`;
        const headers = {};
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get container stats based on resource usage
     * This endpoint returns a live stream of a container’s resource usage
     * statistics.
     *
     * The `precpu_stats` is the CPU statistic of the *previous* read, and is
     * used to calculate the CPU usage percentage. It is not an exact copy
     * of the `cpu_stats` field.
     *
     * If either `precpu_stats.online_cpus` or `cpu_stats.online_cpus` is
     * nil then for compatibility with older daemons the length of the
     * corresponding `cpu_usage.percpu_usage` array should be used.
     *
     * operationId: ContainerStats
     * Request URI: /containers/{id}/stats
     */
    async ContainerStats(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/stats`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            stream: { value: params.parameter.stream, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Resize a container TTY
     * Resize the TTY for a container. You must restart the container for the resize to take effect.
     * operationId: ContainerResize
     * Request URI: /containers/{id}/resize
     */
    async ContainerResize(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/resize`;
        const headers = {};
        const queryParameters = {
            h: { value: params.parameter.h, explode: false },
            w: { value: params.parameter.w, explode: false },
        };
        return this.apiClient.request("POST", url, headers, undefined, queryParameters, option);
    }
    /**
     * Start a container
     * operationId: ContainerStart
     * Request URI: /containers/{id}/start
     */
    async ContainerStart(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/start`;
        const headers = {};
        const queryParameters = {
            detachKeys: { value: params.parameter.detachKeys, explode: false },
        };
        return this.apiClient.request("POST", url, headers, undefined, queryParameters, option);
    }
    /**
     * Stop a container
     * operationId: ContainerStop
     * Request URI: /containers/{id}/stop
     */
    async ContainerStop(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/stop`;
        const headers = {};
        const queryParameters = {
            t: { value: params.parameter.t, explode: false },
        };
        return this.apiClient.request("POST", url, headers, undefined, queryParameters, option);
    }
    /**
     * Restart a container
     * operationId: ContainerRestart
     * Request URI: /containers/{id}/restart
     */
    async ContainerRestart(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/restart`;
        const headers = {};
        const queryParameters = {
            t: { value: params.parameter.t, explode: false },
        };
        return this.apiClient.request("POST", url, headers, undefined, queryParameters, option);
    }
    /**
     * Kill a container
     * Send a POSIX signal to a container, defaulting to killing to the container.
     * operationId: ContainerKill
     * Request URI: /containers/{id}/kill
     */
    async ContainerKill(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/kill`;
        const headers = {};
        const queryParameters = {
            signal: { value: params.parameter.signal, explode: false },
        };
        return this.apiClient.request("POST", url, headers, undefined, queryParameters, option);
    }
    /**
     * Update a container
     * Change various configuration options of a container without having to recreate it.
     * operationId: ContainerUpdate
     * Request URI: /containers/{id}/update
     */
    async ContainerUpdate(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/update`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Rename a container
     * operationId: ContainerRename
     * Request URI: /containers/{id}/rename
     */
    async ContainerRename(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/rename`;
        const headers = {};
        const queryParameters = {
            name: { value: params.parameter.name, explode: false },
        };
        return this.apiClient.request("POST", url, headers, undefined, queryParameters, option);
    }
    /**
     * Pause a container
     * Use the cgroups freezer to suspend all processes in a container.
     *
     * Traditionally, when suspending a process the `SIGSTOP` signal is used, which is observable by the process being suspended. With the cgroups freezer the process is unaware, and unable to capture, that it is being suspended, and subsequently resumed.
     *
     * operationId: ContainerPause
     * Request URI: /containers/{id}/pause
     */
    async ContainerPause(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/pause`;
        const headers = {};
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Unpause a container
     * Resume a container which has been paused.
     * operationId: ContainerUnpause
     * Request URI: /containers/{id}/unpause
     */
    async ContainerUnpause(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/unpause`;
        const headers = {};
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Attach to a container
     * Attach to a container to read its output or send it input. You can attach to the same container multiple times and you can reattach to containers that have been detached.
     *
     * Either the `stream` or `logs` parameter must be `true` for this endpoint to do anything.
     *
     * See [the documentation for the `docker attach` command](/engine/reference/commandline/attach/) for more details.
     *
     * ### Hijacking
     *
     * This endpoint hijacks the HTTP connection to transport `stdin`, `stdout`, and `stderr` on the same socket.
     *
     * This is the response from the daemon for an attach request:
     *
     * ```
     * HTTP/1.1 200 OK
     * Content-Type: application/vnd.docker.raw-stream
     *
     * [STREAM]
     * ```
     *
     * After the headers and two new lines, the TCP connection can now be used for raw, bidirectional communication between the client and server.
     *
     * To hint potential proxies about connection hijacking, the Docker client can also optionally send connection upgrade headers.
     *
     * For example, the client sends this request to upgrade the connection:
     *
     * ```
     * POST /containers/16253994b7c4/attach?stream=1&stdout=1 HTTP/1.1
     * Upgrade: tcp
     * Connection: Upgrade
     * ```
     *
     * The Docker daemon will respond with a `101 UPGRADED` response, and will similarly follow with the raw stream:
     *
     * ```
     * HTTP/1.1 101 UPGRADED
     * Content-Type: application/vnd.docker.raw-stream
     * Connection: Upgrade
     * Upgrade: tcp
     *
     * [STREAM]
     * ```
     *
     * ### Stream format
     *
     * When the TTY setting is disabled in [`POST /containers/create`](#operation/ContainerCreate), the stream over the hijacked connected is multiplexed to separate out `stdout` and `stderr`. The stream consists of a series of frames, each containing a header and a payload.
     *
     * The header contains the information which the stream writes (`stdout` or `stderr`). It also contains the size of the associated frame encoded in the last four bytes (`uint32`).
     *
     * It is encoded on the first eight bytes like this:
     *
     * ```go
     * header := [8]byte{STREAM_TYPE, 0, 0, 0, SIZE1, SIZE2, SIZE3, SIZE4}
     * ```
     *
     * `STREAM_TYPE` can be:
     *
     * - 0: `stdin` (is written on `stdout`)
     * - 1: `stdout`
     * - 2: `stderr`
     *
     * `SIZE1, SIZE2, SIZE3, SIZE4` are the four bytes of the `uint32` size encoded as big endian.
     *
     * Following the header is the payload, which is the specified number of bytes of `STREAM_TYPE`.
     *
     * The simplest way to implement this protocol is the following:
     *
     * 1. Read 8 bytes.
     * 2. Choose `stdout` or `stderr` depending on the first byte.
     * 3. Extract the frame size from the last four bytes.
     * 4. Read the extracted size and output it on the correct output.
     * 5. Goto 1.
     *
     * ### Stream format when using a TTY
     *
     * When the TTY setting is enabled in [`POST /containers/create`](#operation/ContainerCreate), the stream is not multiplexed. The data exchanged over the hijacked connection is simply the raw data from the process PTY and client's `stdin`.
     *
     * operationId: ContainerAttach
     * Request URI: /containers/{id}/attach
     */
    async ContainerAttach(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/attach`;
        const headers = {};
        const queryParameters = {
            detachKeys: { value: params.parameter.detachKeys, explode: false },
            logs: { value: params.parameter.logs, explode: false },
            stream: { value: params.parameter.stream, explode: false },
            stdin: { value: params.parameter.stdin, explode: false },
            stdout: { value: params.parameter.stdout, explode: false },
            stderr: { value: params.parameter.stderr, explode: false },
        };
        return this.apiClient.request("POST", url, headers, undefined, queryParameters, option);
    }
    /**
     * Attach to a container via a websocket
     * operationId: ContainerAttachWebsocket
     * Request URI: /containers/{id}/attach/ws
     */
    async ContainerAttachWebsocket(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/attach/ws`;
        const headers = {};
        const queryParameters = {
            detachKeys: { value: params.parameter.detachKeys, explode: false },
            logs: { value: params.parameter.logs, explode: false },
            stream: { value: params.parameter.stream, explode: false },
            stdin: { value: params.parameter.stdin, explode: false },
            stdout: { value: params.parameter.stdout, explode: false },
            stderr: { value: params.parameter.stderr, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Wait for a container
     * Block until a container stops, then returns the exit code.
     * operationId: ContainerWait
     * Request URI: /containers/{id}/wait
     */
    async ContainerWait(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/wait`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            condition: { value: params.parameter.condition, explode: false },
        };
        return this.apiClient.request("POST", url, headers, undefined, queryParameters, option);
    }
    /**
     * Remove a container
     * operationId: ContainerDelete
     * Request URI: /containers/{id}
     */
    async ContainerDelete(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}`;
        const headers = {};
        const queryParameters = {
            v: { value: params.parameter.v, explode: false },
            force: { value: params.parameter.force, explode: false },
            link: { value: params.parameter.link, explode: false },
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get an archive of a filesystem resource in a container
     * Get a tar archive of a resource in the filesystem of container id.
     * operationId: ContainerArchive
     * Request URI: /containers/{id}/archive
     */
    async ContainerArchive(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/archive`;
        const headers = {};
        const queryParameters = {
            path: { value: params.parameter.path, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Extract an archive of files or folders to a directory in a container
     * Upload a tar archive to be extracted to a path in the filesystem of container id.
     * operationId: PutContainerArchive
     * Request URI: /containers/{id}/archive
     */
    async PutContainerArchive(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/archive`;
        const headers = {
            "Content-Type": params.headers["Content-Type"],
        };
        const queryParameters = {
            path: { value: params.parameter.path, explode: false },
            noOverwriteDirNonDir: { value: params.parameter.noOverwriteDirNonDir, explode: false },
        };
        return this.apiClient.request("PUT", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Get information about files in a container
     * A response header `X-Docker-Container-Path-Stat` is return containing a base64 - encoded JSON object with some filesystem header information about the path.
     * operationId: ContainerArchiveInfo
     * Request URI: /containers/{id}/archive
     */
    async ContainerArchiveInfo(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/archive`;
        const headers = {};
        const queryParameters = {
            path: { value: params.parameter.path, explode: false },
        };
        return this.apiClient.request("HEAD", url, headers, undefined, queryParameters, option);
    }
    /**
     * Delete stopped containers
     * operationId: ContainerPrune
     * Request URI: /containers/prune
     */
    async ContainerPrune(params, option) {
        const url = this.baseUrl + `/containers/prune`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            filters: { value: params.parameter.filters, explode: false },
        };
        return this.apiClient.request("POST", url, headers, undefined, queryParameters, option);
    }
    /**
     * List Images
     * Returns a list of images on the server. Note that it uses a different, smaller representation of an image than inspecting a single image.
     * operationId: ImageList
     * Request URI: /images/json
     */
    async ImageList(params, option) {
        const url = this.baseUrl + `/images/json`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            all: { value: params.parameter.all, explode: false },
            filters: { value: params.parameter.filters, explode: false },
            digests: { value: params.parameter.digests, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Build an image
     * Build an image from a tar archive with a `Dockerfile` in it.
     *
     * The `Dockerfile` specifies how the image is built from the tar archive. It is typically in the archive's root, but can be at a different path or have a different name by specifying the `dockerfile` parameter. [See the `Dockerfile` reference for more information](/engine/reference/builder/).
     *
     * The Docker daemon performs a preliminary validation of the `Dockerfile` before starting the build, and returns an error if the syntax is incorrect. After that, each instruction is run one-by-one until the ID of the new image is output.
     *
     * The build is canceled if the client drops the connection by quitting or being killed.
     *
     * operationId: ImageBuild
     * Request URI: /build
     */
    async ImageBuild(params, option) {
        const url = this.baseUrl + `/build`;
        const headers = {
            "Content-Type": "application/octet-stream",
            "Content-type": params.parameter["Content-type"],
            "X-Registry-Config": params.parameter["X-Registry-Config"],
        };
        const queryParameters = {
            dockerfile: { value: params.parameter.dockerfile, explode: false },
            t: { value: params.parameter.t, explode: false },
            extrahosts: { value: params.parameter.extrahosts, explode: false },
            remote: { value: params.parameter.remote, explode: false },
            q: { value: params.parameter.q, explode: false },
            nocache: { value: params.parameter.nocache, explode: false },
            cachefrom: { value: params.parameter.cachefrom, explode: false },
            pull: { value: params.parameter.pull, explode: false },
            rm: { value: params.parameter.rm, explode: false },
            forcerm: { value: params.parameter.forcerm, explode: false },
            memory: { value: params.parameter.memory, explode: false },
            memswap: { value: params.parameter.memswap, explode: false },
            cpushares: { value: params.parameter.cpushares, explode: false },
            cpusetcpus: { value: params.parameter.cpusetcpus, explode: false },
            cpuperiod: { value: params.parameter.cpuperiod, explode: false },
            cpuquota: { value: params.parameter.cpuquota, explode: false },
            buildargs: { value: params.parameter.buildargs, explode: false },
            shmsize: { value: params.parameter.shmsize, explode: false },
            squash: { value: params.parameter.squash, explode: false },
            labels: { value: params.parameter.labels, explode: false },
            networkmode: { value: params.parameter.networkmode, explode: false },
            platform: { value: params.parameter.platform, explode: false },
            target: { value: params.parameter.target, explode: false },
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Delete builder cache
     * operationId: BuildPrune
     * Request URI: /build/prune
     */
    async BuildPrune(option) {
        const url = this.baseUrl + `/build/prune`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Create an image
     * Create an image by either pulling it from a registry or importing it.
     * operationId: ImageCreate
     * Request URI: /images/create
     */
    async ImageCreate(params, option) {
        const url = this.baseUrl + `/images/create`;
        const headers = {
            "Content-Type": params.headers["Content-Type"],
            "X-Registry-Auth": params.parameter["X-Registry-Auth"],
        };
        const queryParameters = {
            fromImage: { value: params.parameter.fromImage, explode: false },
            fromSrc: { value: params.parameter.fromSrc, explode: false },
            repo: { value: params.parameter.repo, explode: false },
            tag: { value: params.parameter.tag, explode: false },
            platform: { value: params.parameter.platform, explode: false },
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Inspect an image
     * Return low-level information about an image.
     * operationId: ImageInspect
     * Request URI: /images/{name}/json
     */
    async ImageInspect(params, option) {
        const url = this.baseUrl + `/images/${params.parameter.name}/json`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get the history of an image
     * Return parent layers of an image.
     * operationId: ImageHistory
     * Request URI: /images/{name}/history
     */
    async ImageHistory(params, option) {
        const url = this.baseUrl + `/images/${params.parameter.name}/history`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Push an image
     * Push an image to a registry.
     *
     * If you wish to push an image on to a private registry, that image must already have a tag which references the registry. For example, `registry.example.com/myimage:latest`.
     *
     * The push is cancelled if the HTTP connection is closed.
     *
     * operationId: ImagePush
     * Request URI: /images/{name}/push
     */
    async ImagePush(params, option) {
        const url = this.baseUrl + `/images/${params.parameter.name}/push`;
        const headers = {
            "X-Registry-Auth": params.parameter["X-Registry-Auth"],
        };
        const queryParameters = {
            tag: { value: params.parameter.tag, explode: false },
        };
        return this.apiClient.request("POST", url, headers, undefined, queryParameters, option);
    }
    /**
     * Tag an image
     * Tag an image so that it becomes part of a repository.
     * operationId: ImageTag
     * Request URI: /images/{name}/tag
     */
    async ImageTag(params, option) {
        const url = this.baseUrl + `/images/${params.parameter.name}/tag`;
        const headers = {};
        const queryParameters = {
            repo: { value: params.parameter.repo, explode: false },
            tag: { value: params.parameter.tag, explode: false },
        };
        return this.apiClient.request("POST", url, headers, undefined, queryParameters, option);
    }
    /**
     * Remove an image
     * Remove an image, along with any untagged parent images that were
     * referenced by that image.
     *
     * Images can't be removed if they have descendant images, are being
     * used by a running container or are being used by a build.
     *
     * operationId: ImageDelete
     * Request URI: /images/{name}
     */
    async ImageDelete(params, option) {
        const url = this.baseUrl + `/images/${params.parameter.name}`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            force: { value: params.parameter.force, explode: false },
            noprune: { value: params.parameter.noprune, explode: false },
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * Search images
     * Search for an image on Docker Hub.
     * operationId: ImageSearch
     * Request URI: /images/search
     */
    async ImageSearch(params, option) {
        const url = this.baseUrl + `/images/search`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            term: { value: params.parameter.term, explode: false },
            limit: { value: params.parameter.limit, explode: false },
            filters: { value: params.parameter.filters, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Delete unused images
     * operationId: ImagePrune
     * Request URI: /images/prune
     */
    async ImagePrune(params, option) {
        const url = this.baseUrl + `/images/prune`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            filters: { value: params.parameter.filters, explode: false },
        };
        return this.apiClient.request("POST", url, headers, undefined, queryParameters, option);
    }
    /**
     * Check auth configuration
     * Validate credentials for a registry and, if available, get an identity token for accessing the registry without password.
     * operationId: SystemAuth
     * Request URI: /auth
     */
    async SystemAuth(params, option) {
        const url = this.baseUrl + `/auth`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Get system information
     * operationId: SystemInfo
     * Request URI: /info
     */
    async SystemInfo(option) {
        const url = this.baseUrl + `/info`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get version
     * Returns the version of Docker that is running and various information about the system that Docker is running on.
     * operationId: SystemVersion
     * Request URI: /version
     */
    async SystemVersion(option) {
        const url = this.baseUrl + `/version`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Ping
     * This is a dummy endpoint you can use to test if the server is accessible.
     * operationId: SystemPing
     * Request URI: /_ping
     */
    async SystemPing(option) {
        const url = this.baseUrl + `/_ping`;
        const headers = {
            Accept: "text/plain",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Create a new image from a container
     * operationId: ImageCommit
     * Request URI: /commit
     */
    async ImageCommit(params, option) {
        const url = this.baseUrl + `/commit`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        const queryParameters = {
            container: { value: params.parameter.container, explode: false },
            repo: { value: params.parameter.repo, explode: false },
            tag: { value: params.parameter.tag, explode: false },
            comment: { value: params.parameter.comment, explode: false },
            author: { value: params.parameter.author, explode: false },
            pause: { value: params.parameter.pause, explode: false },
            changes: { value: params.parameter.changes, explode: false },
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Monitor events
     * Stream real-time events from the server.
     *
     * Various objects within Docker report events when something happens to them.
     *
     * Containers report these events: `attach`, `commit`, `copy`, `create`, `destroy`, `detach`, `die`, `exec_create`, `exec_detach`, `exec_start`, `exec_die`, `export`, `health_status`, `kill`, `oom`, `pause`, `rename`, `resize`, `restart`, `start`, `stop`, `top`, `unpause`, and `update`
     *
     * Images report these events: `delete`, `import`, `load`, `pull`, `push`, `save`, `tag`, and `untag`
     *
     * Volumes report these events: `create`, `mount`, `unmount`, and `destroy`
     *
     * Networks report these events: `create`, `connect`, `disconnect`, `destroy`, `update`, and `remove`
     *
     * The Docker daemon reports these events: `reload`
     *
     * Services report these events: `create`, `update`, and `remove`
     *
     * Nodes report these events: `create`, `update`, and `remove`
     *
     * Secrets report these events: `create`, `update`, and `remove`
     *
     * Configs report these events: `create`, `update`, and `remove`
     *
     * operationId: SystemEvents
     * Request URI: /events
     */
    async SystemEvents(params, option) {
        const url = this.baseUrl + `/events`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            since: { value: params.parameter.since, explode: false },
            until: { value: params.parameter.until, explode: false },
            filters: { value: params.parameter.filters, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get data usage information
     * operationId: SystemDataUsage
     * Request URI: /system/df
     */
    async SystemDataUsage(params, option) {
        const url = this.baseUrl + `/system/df`;
        const headers = {
            Accept: params.headers.Accept,
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Export an image
     * Get a tarball containing all images and metadata for a repository.
     *
     * If `name` is a specific name and tag (e.g. `ubuntu:latest`), then only that image (and its parents) are returned. If `name` is an image ID, similarly only that image (and its parents) are returned, but with the exclusion of the `repositories` file in the tarball, as there were no image names referenced.
     *
     * ### Image tarball format
     *
     * An image tarball contains one directory per image layer (named using its long ID), each containing these files:
     *
     * - `VERSION`: currently `1.0` - the file format version
     * - `json`: detailed layer information, similar to `docker inspect layer_id`
     * - `layer.tar`: A tarfile containing the filesystem changes in this layer
     *
     * The `layer.tar` file contains `aufs` style `.wh..wh.aufs` files and directories for storing attribute changes and deletions.
     *
     * If the tarball defines a repository, the tarball should also include a `repositories` file at the root that contains a list of repository and tag names mapped to layer IDs.
     *
     * ```json
     * {
     *   "hello-world": {
     *     "latest": "565a9d68a73f6706862bfe8409a7f659776d4d60a8d096eb4a3cbce6999cc2a1"
     *   }
     * }
     * ```
     *
     * operationId: ImageGet
     * Request URI: /images/{name}/get
     */
    async ImageGet(params, option) {
        const url = this.baseUrl + `/images/${params.parameter.name}/get`;
        const headers = {
            Accept: "application/x-tar",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Export several images
     * Get a tarball containing all images and metadata for several image repositories.
     *
     * For each value of the `names` parameter: if it is a specific name and tag (e.g. `ubuntu:latest`), then only that image (and its parents) are returned; if it is an image ID, similarly only that image (and its parents) are returned and there would be no names referenced in the 'repositories' file for this image ID.
     *
     * For details on the format, see [the export image endpoint](#operation/ImageGet).
     *
     * operationId: ImageGetAll
     * Request URI: /images/get
     */
    async ImageGetAll(params, option) {
        const url = this.baseUrl + `/images/get`;
        const headers = {
            Accept: "application/x-tar",
        };
        const queryParameters = {
            names: { value: params.parameter.names, style: "form", explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Import images
     * Load a set of images and tags into a repository.
     *
     * For details on the format, see [the export image endpoint](#operation/ImageGet).
     *
     * operationId: ImageLoad
     * Request URI: /images/load
     */
    async ImageLoad(params, option) {
        const url = this.baseUrl + `/images/load`;
        const headers = {
            "Content-Type": "application/x-tar",
        };
        const queryParameters = {
            quiet: { value: params.parameter.quiet, explode: false },
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Create an exec instance
     * Run a command inside a running container.
     * operationId: ContainerExec
     * Request URI: /containers/{id}/exec
     */
    async ContainerExec(params, option) {
        const url = this.baseUrl + `/containers/${params.parameter.id}/exec`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Start an exec instance
     * Starts a previously set up exec instance. If detach is true, this endpoint returns immediately after starting the command. Otherwise, it sets up an interactive session with the command.
     * operationId: ExecStart
     * Request URI: /exec/{id}/start
     */
    async ExecStart(params, option) {
        const url = this.baseUrl + `/exec/${params.parameter.id}/start`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Resize an exec instance
     * Resize the TTY session used by an exec instance. This endpoint only works if `tty` was specified as part of creating and starting the exec instance.
     * operationId: ExecResize
     * Request URI: /exec/{id}/resize
     */
    async ExecResize(params, option) {
        const url = this.baseUrl + `/exec/${params.parameter.id}/resize`;
        const headers = {};
        const queryParameters = {
            h: { value: params.parameter.h, explode: false },
            w: { value: params.parameter.w, explode: false },
        };
        return this.apiClient.request("POST", url, headers, undefined, queryParameters, option);
    }
    /**
     * Inspect an exec instance
     * Return low-level information about an exec instance.
     * operationId: ExecInspect
     * Request URI: /exec/{id}/json
     */
    async ExecInspect(params, option) {
        const url = this.baseUrl + `/exec/${params.parameter.id}/json`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * List volumes
     * operationId: VolumeList
     * Request URI: /volumes
     */
    async VolumeList(params, option) {
        const url = this.baseUrl + `/volumes`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            filters: { value: params.parameter.filters, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a volume
     * operationId: VolumeCreate
     * Request URI: /volumes/create
     */
    async VolumeCreate(params, option) {
        const url = this.baseUrl + `/volumes/create`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Inspect a volume
     * operationId: VolumeInspect
     * Request URI: /volumes/{name}
     */
    async VolumeInspect(params, option) {
        const url = this.baseUrl + `/volumes/${params.parameter.name}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Remove a volume
     * Instruct the driver to remove the volume.
     * operationId: VolumeDelete
     * Request URI: /volumes/{name}
     */
    async VolumeDelete(params, option) {
        const url = this.baseUrl + `/volumes/${params.parameter.name}`;
        const headers = {};
        const queryParameters = {
            force: { value: params.parameter.force, explode: false },
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * Delete unused volumes
     * operationId: VolumePrune
     * Request URI: /volumes/prune
     */
    async VolumePrune(params, option) {
        const url = this.baseUrl + `/volumes/prune`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            filters: { value: params.parameter.filters, explode: false },
        };
        return this.apiClient.request("POST", url, headers, undefined, queryParameters, option);
    }
    /**
     * List networks
     * Returns a list of networks. For details on the format, see [the network inspect endpoint](#operation/NetworkInspect).
     *
     * Note that it uses a different, smaller representation of a network than inspecting a single network. For example,
     * the list of containers attached to the network is not propagated in API versions 1.28 and up.
     *
     * operationId: NetworkList
     * Request URI: /networks
     */
    async NetworkList(params, option) {
        const url = this.baseUrl + `/networks`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            filters: { value: params.parameter.filters, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Inspect a network
     * operationId: NetworkInspect
     * Request URI: /networks/{id}
     */
    async NetworkInspect(params, option) {
        const url = this.baseUrl + `/networks/${params.parameter.id}`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            verbose: { value: params.parameter.verbose, explode: false },
            scope: { value: params.parameter.scope, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Remove a network
     * operationId: NetworkDelete
     * Request URI: /networks/{id}
     */
    async NetworkDelete(params, option) {
        const url = this.baseUrl + `/networks/${params.parameter.id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Create a network
     * operationId: NetworkCreate
     * Request URI: /networks/create
     */
    async NetworkCreate(params, option) {
        const url = this.baseUrl + `/networks/create`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Connect a container to a network
     * operationId: NetworkConnect
     * Request URI: /networks/{id}/connect
     */
    async NetworkConnect(params, option) {
        const url = this.baseUrl + `/networks/${params.parameter.id}/connect`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Disconnect a container from a network
     * operationId: NetworkDisconnect
     * Request URI: /networks/{id}/disconnect
     */
    async NetworkDisconnect(params, option) {
        const url = this.baseUrl + `/networks/${params.parameter.id}/disconnect`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Delete unused networks
     * operationId: NetworkPrune
     * Request URI: /networks/prune
     */
    async NetworkPrune(params, option) {
        const url = this.baseUrl + `/networks/prune`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            filters: { value: params.parameter.filters, explode: false },
        };
        return this.apiClient.request("POST", url, headers, undefined, queryParameters, option);
    }
    /**
     * List plugins
     * Returns information about installed plugins.
     * operationId: PluginList
     * Request URI: /plugins
     */
    async PluginList(params, option) {
        const url = this.baseUrl + `/plugins`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            filters: { value: params.parameter.filters, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Get plugin privileges
     * operationId: GetPluginPrivileges
     * Request URI: /plugins/privileges
     */
    async GetPluginPrivileges(params, option) {
        const url = this.baseUrl + `/plugins/privileges`;
        const headers = {
            Accept: params.headers.Accept,
        };
        const queryParameters = {
            remote: { value: params.parameter.remote, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Install a plugin
     * Pulls and installs a plugin. After the plugin is installed, it can be enabled using the [`POST /plugins/{name}/enable` endpoint](#operation/PostPluginsEnable).
     *
     * operationId: PluginPull
     * Request URI: /plugins/pull
     */
    async PluginPull(params, option) {
        const url = this.baseUrl + `/plugins/pull`;
        const headers = {
            "Content-Type": params.headers["Content-Type"],
            "X-Registry-Auth": params.parameter["X-Registry-Auth"],
        };
        const queryParameters = {
            remote: { value: params.parameter.remote, explode: false },
            name: { value: params.parameter.name, explode: false },
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Inspect a plugin
     * operationId: PluginInspect
     * Request URI: /plugins/{name}/json
     */
    async PluginInspect(params, option) {
        const url = this.baseUrl + `/plugins/${params.parameter.name}/json`;
        const headers = {
            Accept: params.headers.Accept,
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Remove a plugin
     * operationId: PluginDelete
     * Request URI: /plugins/{name}
     */
    async PluginDelete(params, option) {
        const url = this.baseUrl + `/plugins/${params.parameter.name}`;
        const headers = {
            Accept: params.headers.Accept,
        };
        const queryParameters = {
            force: { value: params.parameter.force, explode: false },
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * Enable a plugin
     * operationId: PluginEnable
     * Request URI: /plugins/{name}/enable
     */
    async PluginEnable(params, option) {
        const url = this.baseUrl + `/plugins/${params.parameter.name}/enable`;
        const headers = {};
        const queryParameters = {
            timeout: { value: params.parameter.timeout, explode: false },
        };
        return this.apiClient.request("POST", url, headers, undefined, queryParameters, option);
    }
    /**
     * Disable a plugin
     * operationId: PluginDisable
     * Request URI: /plugins/{name}/disable
     */
    async PluginDisable(params, option) {
        const url = this.baseUrl + `/plugins/${params.parameter.name}/disable`;
        const headers = {};
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Upgrade a plugin
     * operationId: PluginUpgrade
     * Request URI: /plugins/{name}/upgrade
     */
    async PluginUpgrade(params, option) {
        const url = this.baseUrl + `/plugins/${params.parameter.name}/upgrade`;
        const headers = {
            "Content-Type": params.headers["Content-Type"],
            "X-Registry-Auth": params.parameter["X-Registry-Auth"],
        };
        const queryParameters = {
            remote: { value: params.parameter.remote, explode: false },
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Create a plugin
     * operationId: PluginCreate
     * Request URI: /plugins/create
     */
    async PluginCreate(params, option) {
        const url = this.baseUrl + `/plugins/create`;
        const headers = {
            "Content-Type": "application/x-tar",
        };
        const queryParameters = {
            name: { value: params.parameter.name, explode: false },
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Push a plugin
     * Push a plugin to the registry.
     *
     * operationId: PluginPush
     * Request URI: /plugins/{name}/push
     */
    async PluginPush(params, option) {
        const url = this.baseUrl + `/plugins/${params.parameter.name}/push`;
        const headers = {};
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
    /**
     * Configure a plugin
     * operationId: PluginSet
     * Request URI: /plugins/{name}/set
     */
    async PluginSet(params, option) {
        const url = this.baseUrl + `/plugins/${params.parameter.name}/set`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List nodes
     * operationId: NodeList
     * Request URI: /nodes
     */
    async NodeList(params, option) {
        const url = this.baseUrl + `/nodes`;
        const headers = {
            Accept: params.headers.Accept,
        };
        const queryParameters = {
            filters: { value: params.parameter.filters, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Inspect a node
     * operationId: NodeInspect
     * Request URI: /nodes/{id}
     */
    async NodeInspect(params, option) {
        const url = this.baseUrl + `/nodes/${params.parameter.id}`;
        const headers = {
            Accept: params.headers.Accept,
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a node
     * operationId: NodeDelete
     * Request URI: /nodes/{id}
     */
    async NodeDelete(params, option) {
        const url = this.baseUrl + `/nodes/${params.parameter.id}`;
        const headers = {};
        const queryParameters = {
            force: { value: params.parameter.force, explode: false },
        };
        return this.apiClient.request("DELETE", url, headers, undefined, queryParameters, option);
    }
    /**
     * Update a node
     * operationId: NodeUpdate
     * Request URI: /nodes/{id}/update
     */
    async NodeUpdate(params, option) {
        const url = this.baseUrl + `/nodes/${params.parameter.id}/update`;
        const headers = {
            "Content-Type": params.headers["Content-Type"],
        };
        const queryParameters = {
            version: { value: params.parameter.version, explode: false },
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Inspect swarm
     * operationId: SwarmInspect
     * Request URI: /swarm
     */
    async SwarmInspect(params, option) {
        const url = this.baseUrl + `/swarm`;
        const headers = {
            Accept: params.headers.Accept,
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Initialize a new swarm
     * operationId: SwarmInit
     * Request URI: /swarm/init
     */
    async SwarmInit(params, option) {
        const url = this.baseUrl + `/swarm/init`;
        const headers = {
            "Content-Type": params.headers["Content-Type"],
            Accept: params.headers.Accept,
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Join an existing swarm
     * operationId: SwarmJoin
     * Request URI: /swarm/join
     */
    async SwarmJoin(params, option) {
        const url = this.baseUrl + `/swarm/join`;
        const headers = {
            "Content-Type": params.headers["Content-Type"],
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Leave a swarm
     * operationId: SwarmLeave
     * Request URI: /swarm/leave
     */
    async SwarmLeave(params, option) {
        const url = this.baseUrl + `/swarm/leave`;
        const headers = {};
        const queryParameters = {
            force: { value: params.parameter.force, explode: false },
        };
        return this.apiClient.request("POST", url, headers, undefined, queryParameters, option);
    }
    /**
     * Update a swarm
     * operationId: SwarmUpdate
     * Request URI: /swarm/update
     */
    async SwarmUpdate(params, option) {
        const url = this.baseUrl + `/swarm/update`;
        const headers = {
            "Content-Type": params.headers["Content-Type"],
        };
        const queryParameters = {
            version: { value: params.parameter.version, explode: false },
            rotateWorkerToken: { value: params.parameter.rotateWorkerToken, explode: false },
            rotateManagerToken: { value: params.parameter.rotateManagerToken, explode: false },
            rotateManagerUnlockKey: { value: params.parameter.rotateManagerUnlockKey, explode: false },
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Get the unlock key
     * operationId: SwarmUnlockkey
     * Request URI: /swarm/unlockkey
     */
    async SwarmUnlockkey(params, option) {
        const url = this.baseUrl + `/swarm/unlockkey`;
        const headers = {
            Accept: params.headers.Accept,
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Unlock a locked manager
     * operationId: SwarmUnlock
     * Request URI: /swarm/unlock
     */
    async SwarmUnlock(params, option) {
        const url = this.baseUrl + `/swarm/unlock`;
        const headers = {
            "Content-Type": "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * List services
     * operationId: ServiceList
     * Request URI: /services
     */
    async ServiceList(params, option) {
        const url = this.baseUrl + `/services`;
        const headers = {
            Accept: params.headers.Accept,
        };
        const queryParameters = {
            filters: { value: params.parameter.filters, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a service
     * operationId: ServiceCreate
     * Request URI: /services/create
     */
    async ServiceCreate(params, option) {
        const url = this.baseUrl + `/services/create`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
            "X-Registry-Auth": params.parameter["X-Registry-Auth"],
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Inspect a service
     * operationId: ServiceInspect
     * Request URI: /services/{id}
     */
    async ServiceInspect(params, option) {
        const url = this.baseUrl + `/services/${params.parameter.id}`;
        const headers = {
            Accept: params.headers.Accept,
        };
        const queryParameters = {
            insertDefaults: { value: params.parameter.insertDefaults, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Delete a service
     * operationId: ServiceDelete
     * Request URI: /services/{id}
     */
    async ServiceDelete(params, option) {
        const url = this.baseUrl + `/services/${params.parameter.id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a service
     * operationId: ServiceUpdate
     * Request URI: /services/{id}/update
     */
    async ServiceUpdate(params, option) {
        const url = this.baseUrl + `/services/${params.parameter.id}/update`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
            "X-Registry-Auth": params.parameter["X-Registry-Auth"],
        };
        const queryParameters = {
            version: { value: params.parameter.version, explode: false },
            registryAuthFrom: { value: params.parameter.registryAuthFrom, explode: false },
            rollback: { value: params.parameter.rollback, explode: false },
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Get service logs
     * Get `stdout` and `stderr` logs from a service.
     *
     * **Note**: This endpoint works only for services with the `json-file` or `journald` logging drivers.
     *
     * operationId: ServiceLogs
     * Request URI: /services/{id}/logs
     */
    async ServiceLogs(params, option) {
        const url = this.baseUrl + `/services/${params.parameter.id}/logs`;
        const headers = {
            Accept: params.headers.Accept,
        };
        const queryParameters = {
            details: { value: params.parameter.details, explode: false },
            follow: { value: params.parameter.follow, explode: false },
            stdout: { value: params.parameter.stdout, explode: false },
            stderr: { value: params.parameter.stderr, explode: false },
            since: { value: params.parameter.since, explode: false },
            timestamps: { value: params.parameter.timestamps, explode: false },
            tail: { value: params.parameter.tail, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List tasks
     * operationId: TaskList
     * Request URI: /tasks
     */
    async TaskList(params, option) {
        const url = this.baseUrl + `/tasks`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            filters: { value: params.parameter.filters, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Inspect a task
     * operationId: TaskInspect
     * Request URI: /tasks/{id}
     */
    async TaskInspect(params, option) {
        const url = this.baseUrl + `/tasks/${params.parameter.id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Get task logs
     * Get `stdout` and `stderr` logs from a task.
     *
     * **Note**: This endpoint works only for services with the `json-file` or `journald` logging drivers.
     *
     * operationId: TaskLogs
     * Request URI: /tasks/{id}/logs
     */
    async TaskLogs(params, option) {
        const url = this.baseUrl + `/tasks/${params.parameter.id}/logs`;
        const headers = {
            Accept: params.headers.Accept,
        };
        const queryParameters = {
            details: { value: params.parameter.details, explode: false },
            follow: { value: params.parameter.follow, explode: false },
            stdout: { value: params.parameter.stdout, explode: false },
            stderr: { value: params.parameter.stderr, explode: false },
            since: { value: params.parameter.since, explode: false },
            timestamps: { value: params.parameter.timestamps, explode: false },
            tail: { value: params.parameter.tail, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * List secrets
     * operationId: SecretList
     * Request URI: /secrets
     */
    async SecretList(params, option) {
        const url = this.baseUrl + `/secrets`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            filters: { value: params.parameter.filters, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a secret
     * operationId: SecretCreate
     * Request URI: /secrets/create
     */
    async SecretCreate(params, option) {
        const url = this.baseUrl + `/secrets/create`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Inspect a secret
     * operationId: SecretInspect
     * Request URI: /secrets/{id}
     */
    async SecretInspect(params, option) {
        const url = this.baseUrl + `/secrets/${params.parameter.id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a secret
     * operationId: SecretDelete
     * Request URI: /secrets/{id}
     */
    async SecretDelete(params, option) {
        const url = this.baseUrl + `/secrets/${params.parameter.id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a Secret
     * operationId: SecretUpdate
     * Request URI: /secrets/{id}/update
     */
    async SecretUpdate(params, option) {
        const url = this.baseUrl + `/secrets/${params.parameter.id}/update`;
        const headers = {
            "Content-Type": params.headers["Content-Type"],
        };
        const queryParameters = {
            version: { value: params.parameter.version, explode: false },
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * List configs
     * operationId: ConfigList
     * Request URI: /configs
     */
    async ConfigList(params, option) {
        const url = this.baseUrl + `/configs`;
        const headers = {
            Accept: "application/json",
        };
        const queryParameters = {
            filters: { value: params.parameter.filters, explode: false },
        };
        return this.apiClient.request("GET", url, headers, undefined, queryParameters, option);
    }
    /**
     * Create a config
     * operationId: ConfigCreate
     * Request URI: /configs/create
     */
    async ConfigCreate(params, option) {
        const url = this.baseUrl + `/configs/create`;
        const headers = {
            "Content-Type": "application/json",
            Accept: "application/json",
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, undefined, option);
    }
    /**
     * Inspect a config
     * operationId: ConfigInspect
     * Request URI: /configs/{id}
     */
    async ConfigInspect(params, option) {
        const url = this.baseUrl + `/configs/${params.parameter.id}`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Delete a config
     * operationId: ConfigDelete
     * Request URI: /configs/{id}
     */
    async ConfigDelete(params, option) {
        const url = this.baseUrl + `/configs/${params.parameter.id}`;
        const headers = {};
        return this.apiClient.request("DELETE", url, headers, undefined, undefined, option);
    }
    /**
     * Update a Config
     * operationId: ConfigUpdate
     * Request URI: /configs/{id}/update
     */
    async ConfigUpdate(params, option) {
        const url = this.baseUrl + `/configs/${params.parameter.id}/update`;
        const headers = {
            "Content-Type": params.headers["Content-Type"],
        };
        const queryParameters = {
            version: { value: params.parameter.version, explode: false },
        };
        return this.apiClient.request("POST", url, headers, params.requestBody, queryParameters, option);
    }
    /**
     * Get image information from the registry
     * Return image digest and platform information by contacting the registry.
     * operationId: DistributionInspect
     * Request URI: /distribution/{name}/json
     */
    async DistributionInspect(params, option) {
        const url = this.baseUrl + `/distribution/${params.parameter.name}/json`;
        const headers = {
            Accept: "application/json",
        };
        return this.apiClient.request("GET", url, headers, undefined, undefined, option);
    }
    /**
     * Initialize interactive session
     * Start a new interactive session with a server. Session allows server to call back to the client for advanced capabilities.
     *
     * > **Note**: This endpoint is *experimental* and only available if the daemon is started with experimental
     * > features enabled. The specifications for this endpoint may still change in a future version of the API.
     *
     * ### Hijacking
     *
     * This endpoint hijacks the HTTP connection to HTTP2 transport that allows the client to expose gPRC services on that connection.
     *
     * For example, the client sends this request to upgrade the connection:
     *
     * ```
     * POST /session HTTP/1.1
     * Upgrade: h2c
     * Connection: Upgrade
     * ```
     *
     * The Docker daemon will respond with a `101 UPGRADED` response follow with the raw stream:
     *
     * ```
     * HTTP/1.1 101 UPGRADED
     * Connection: Upgrade
     * Upgrade: h2c
     * ```
     *
     * operationId: Session
     * Request URI: /session
     */
    async Session(option) {
        const url = this.baseUrl + `/session`;
        const headers = {};
        return this.apiClient.request("POST", url, headers, undefined, undefined, option);
    }
}
