/// <reference types="node" />
import * as http from "http";
import type * as stream from "stream";
export interface CreateRequestArgs {
    requestOptions: http.RequestOptions;
    requestBody?: string;
    hijack?: boolean;
    callback?: (sock: stream.Readable) => void;
    /** millseconds */
    timeout?: number;
}
export interface CreateResponseArgs {
    res: http.IncomingMessage;
    isStream?: boolean;
    callback?: (res: stream.Readable) => void;
}
export interface RequestArgs {
    socketPath: string;
    method?: string;
    path?: string;
    headers?: http.OutgoingHttpHeaders;
    requestBody?: any;
    hijack?: boolean;
    isStream?: boolean;
    onHijackRequest?: (stream: stream.Readable) => void;
    onResponse?: (stream: stream.Readable) => void;
    /** millseconds */
    timeout?: number;
}
export declare const request: (args: RequestArgs) => Promise<any>;
